mainApp/urls.py
from django.urls import path
from .views import *


urlpatterns = [
    path("", Listing, name="listing"),
    path("add/", Add, name="add"),
    path("edit/<pk>", Editing, name="edit"),
    path("destroy/<pk>", Destroying, name="destroy"),
    path("", login_required(Listing), name="listing-notes"),
    path("notes/add/", login_required(Add), name="add-notes"),
    path("notes/edit/<pk>", login_required(Editing), name="edit-notes"),
    path("notes/destroy/<pk>", login_required(Destroying), name="destroy-notes"),
    path("licenses/", login_required(LicenseList.as_view()) , name="listing-licenses" ),
    path("licenses/add/", login_required(LicenseAdd.as_view()), name="listing-add"),
    path("licenses/edit/<pk>", login_required(LicenseEdit.as_view()), name="listing-update"),
    path("licenses/delete/<pk>", login_required(LicenseDelete.as_view()), name="listing-delete"),
    path("personal/", login_required(PersonalList.as_view()), name="listing-personal"),
    path("personal/add/", login_required(PersonalAdd.as_view()), name="personal-add"),
    path("personal/edit/<pk>", login_required(PersonalEdit.as_view()), name="personal-edit"),
    path("personal/delete/<pk>", login_required(PersonalDelete.as_view()), name="personal-delete"),
]

wholeNotes/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('', include('mainApp.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('allauth.urls')),
]

if settings.DEBUG:
    urlpatterns + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

mainApp/models.py
from django.db import models
import uuid
from django.utils import timezone

class Personal(models.Model):
    id = models.CharField(max_length=128, primary_key=True, default=uuid.uuid4)
    name = models.CharField(max_length=32)
    computer_code = models.CharField(max_length=32)
    ubication = models.CharField(max_length=32)
    last_updated = models.DateTimeField(auto_now=True)
    def __str__(self):
        return self.name+ ' ' +self.computer_code

class License(models.Model):
    id = models.CharField(max_length=128, primary_key=True, default=uuid.uuid4)
    software_name = models.CharField(max_length=50)
    key = models.CharField(max_length=32)
    description = models.TextField(blank=True)
    owner = models.ForeignKey(Personal, on_delete=models.DO_NOTHING)

class Note(models.Model):
    id = models.CharField(max_length=128, primary_key=True, default=uuid.uuid4)
    software = models.CharField(max_length=50, blank=True)
    version = models.CharField(max_length=15, blank=True, null=True)
    description = models.TextField(blank=True)
    date_created = models.DateTimeField(default=timezone.now)
    owner = models.ForeignKey(Personal, on_delete=models.DO_NOTHING)
    class Meta:
        ordering = ['-date_created']

    #correlative
    #manager
    #email

mainApp/forms.py
from django.forms import ModelForm
from .models import Note, License, Personal
from django.forms import ModelForm, Textarea

class NotesForm(ModelForm):
    class Meta:
        model = Note
        fields = ('software', 'version', 'description', 'date_created', 'owner')
        #fields = '__all__'
        """widgets = {
            'description' : Textarea(attrs={'cols': 20, 'rows': 10}),
        }"""


class LicensesForm(ModelForm):
    class Meta:
        model = License
        fields = ('software_name', 'key' ,'description', 'owner')
        #fields = '__all__'

class PersonalForm(ModelForm):
    class Meta:
        model = Personal
        fields = ('name', 'computer_code', 'ubication')

mainApp/views.py
from django.shortcuts import render, redirect, render_to_response
from django.http import HttpResponse
from .forms import *
import uuid
from .models import *
from django.contrib.auth.decorators import login_required
#Importing generic viewsl
from django.http import HttpResponseRedirect
from django.views.generic.base import TemplateView
from django.views.generic import ListView, DetailView 
from django.views.generic.edit import CreateView, UpdateView, DeleteView, FormView
from django.urls import reverse_lazy

@login_required()
def Add(request):
    if request.method == "POST":
        form = NotesForm(request.POST)
        if form.is_valid():
            data = form.save(commit=False)
            data.id = uuid.uuid4()
            data.software = request.POST['software']
            data.version = request.POST.get('version')
            data.description = request.POST['description']
            data.date_created = timezone.now()
            data.save()
            return redirect('listing-notes')
    return render(request, 'software/add.html', {'form': NotesForm()})

@login_required()
def Listing(request):
    data = Note.objects.all()
    return render(request, 'software/show.html', {'list': data})
@login_required()
def Editing(request, pk): 
    form = NotesForm(request.POST or None, instance=Note.objects.get(id=pk))
    if request.method == "POST":
        if form.is_valid():
            data = form.save(commit=False)
            data.code = request.POST['code']
            data.software = request.POST['software']
            data.version = request.POST.get('version')
            data.description = request.POST['description']
            data.date_created = timezone.now()
            data.save()
            return redirect('listing-notes')
    return render(request, 'software/add.html', {'form': form})


@login_required()
def Destroying(request, pk): 
    data = Note.objects.get(id=pk)
    aux = data
    data.delete()
    return render(request, 'software/destroy.html', {'data': aux})

class LicenseList(ListView):
    model = License
    template_name = 'licenses/show.html'

class LicenseAdd(FormView):
    model = License
    form_class = LicensesForm
    template_name = 'licenses/add.html'
    success_url = '/licenses/'

    def form_valid(self, form):
        form.id = uuid.uuid4()
        form.save()
        return super().form_valid(form)

class LicenseEdit(UpdateView):
    model = License
    form_class = LicensesForm
    template_name = 'licenses/add.html'
    success_url = reverse_lazy("listing-licenses")


class LicenseDelete(DeleteView):
    model = License
    success_url = reverse_lazy("listing-licenses")
    #def get_success_url(self, *args, **kwargs):
    #    context = self.kwargs['pk']
    #    return  reverse_lazy('listing-delete', kwargs={'pk': context})
    def get(self, *args, **kwargs):
        data = self.get_object()
        info = {'id': data.id, 'software_name': data.software_name, 'key': data.key, 'description': data.description}
        self.delete(*args, **kwargs)
        return render_to_response( 'licenses/destroy.html', {'object': info})

class PersonalList(ListView):
    model = Personal
    template_name = 'personal/show.html'

class PersonalAdd(FormView):
    model = Personal
    form_class = PersonalForm
    template_name = 'personal/add.html'
    success_url = reverse_lazy('listing-personal')

    def form_valid(self, form):
        form.id = uuid.uuid4()
        form.save()
        return super().form_valid(form)

class PersonalEdit(UpdateView):
    model = Personal
    form_class = PersonalForm
    template_name = 'personal/add.html'
    success_url = reverse_lazy('listing-personal')

class PersonalDelete(DeleteView):
    model = Personal
    success_url = reverse_lazy('listing-personal')

    def get(self, *args, **kwargs):
        data = self.get_object()
        info = {'id': data.id, 'name': data.name, 'computer_code': data.computer_code, 'ubication': data.ubication}
        self.delete(*args, **kwargs)
        return render_to_response( 'personal/destroy.html', {'object': info})
"""
from django.http import Http404
    def get_object(self, queryset=None):
        # Hook to ensure object is owned by request.user.
        obj = super(MyDeleteView, self).get_object()
        if not obj.owner == self.request.user:
            raise Http404
        return obj"""
        

templates/base.html
{% load widget_tweaks %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>My little title</title>
    <!-- Compressed CSS -->
    <!--<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/foundation-sites@6.5.3/dist/css/foundation.min.css" integrity="sha256-xpOKVlYXzQ3P03j397+jWFZLMBXLES3IiryeClgU5og= sha384-gP4DhqyoT9b1vaikoHi9XQ8If7UNLO73JFOOlQV1RATrA7D0O7TjJZifac6NwPps sha512-AKwIib1E+xDeXe0tCgbc9uSvPwVYl6Awj7xl0FoaPFostZHOuDQ1abnDNCYtxL/HWEnVOMrFyf91TDgLPi9pNg==" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/foundation-sites@6.5.3/dist/css/foundation-float.min.css" integrity="sha256-sP0p6J7SbJGiJ2gkdY1nkVsLgdwiFN2kI370lU+zacQ= sha384-yZLxxcD8nfiSt1qfKJWwHwtkL58WZDTlkBnZN60qr3ZS35+LDsmUF2JHLxdyZ+KU sha512-Z3WbpfWFSsK2dBvoSYZnMvPmxSJUa5cxj3TYlmyj6cq8IXy7iB2nlUk+jjms8gnz4HmpQk/yhRSlRzW7keoSlg==" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/foundation-sites@6.5.3/dist/css/foundation-prototype.min.css" integrity="sha256-ksLmXa0k3ACbX6azB9g6l7XlmSKFBkuH0DXKNwULXtE= sha384-RGTvu65DAT+yLQsTj5tnITDrMfrS5mbajNAYILSg4hHr9vRr/3Y9q0WAdChqLKfx sha512-KMJ7XYrv5UcwEvJFaYnLSdN5O3fT7aQvjed//LQPB3AsN4VPA/wXG9j4x4vKZkjNmU/U8aZC9Ac3FYxs9lPXcw==" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/foundation-sites@6.5.3/dist/css/foundation-rtl.min.css" integrity="sha256-jvk46bzgetf2fy3FF19toDOoy9CG3aFqZfd229doSyo= sha384-w6E9ynA6OV6MFswc7C8nr8QoBiRtqqOKF/5M9ZVyVDDyrUPLI75xizNuXgRZxWK5 sha512-7MZk47L+5Mj6Y0dP3NuB2aqlNdDgzTlCf8m50nvgnCHUbxZ9KabCy8VUzQAl/DqDKwR7E6JsCf1MUjkfCiVzJw==" crossorigin="anonymous">-->
    <link rel="stylesheet" href="{% static 'css/foundation.css' %}">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    
</head>
<body>
    <nav id="main-nav-bar" class="top-bar">
        <div class="top-bar-left">
            <ul class="menu">
                <li class="menu-text">WholeNotes</li>
            </ul>
        </div>
        <div class="top-bar-right">
            <ul class="menu">
                <li><a href="{% url 'listing-notes' %}">Notes</a></li>
                <li><a href="{% url 'listing-licenses' %}">License</a></li>
                <li><a href="{% url 'listing-personal' %}">Personal</a></li>
            </ul>
        </div> 
    </nav>
    <div class="row">
        <div class="columns small-12 medium-12 large-12">
            {% block content %}
            {% endblock content%}
        </div>    
    </div>
    <div id="app">
        <!--<p>[[message]]</p>-->
    </div>
    <script type="text/javscript" src="{% static 'js/vendor/jquery.js'%}"></script>
    <script type="text/javscript" src="{% static 'js/app.js'%}"></script>
    <script type="text/javscript" src="{% static 'js/vendor/foundation.js'%}"></script>
    <script type="text/javscript" src="{% static 'js/vendor/what-input.js'%}"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script>
        new Vue({ delimiters: ['$[', ']'] })
    </script>    
    
</body>
</html>

templates/licenses/add.html
{% extends 'base.html' %}
{% load widget_tweaks %}
{% block content %}
    <h2 style="margin: 0 auto;">Adding TI Licenses</h2>
    <form method="POST">
        {% csrf_token %}
        <div>
            <label for="id_software_name">{{form.software_name.label}}</label>
            {% render_field form.software_name %}
        </div>
        <div>
            <label for="id_owner">{{form.owner.label}}</label>
            {% render_field form.owner%}
        </div>
        <div>
            <label for="id_key">{{form.key.label}}</label>
            {% render_field form.key%}
        </div>
        <div>
            <label for="id_description">{{form.description.label}}</label>
            {% render_field form.description %}
        </div>
        <div class="colums center-items">
            <input class="button" type="submit" value="+">
        </div>
    </form>
{% endblock content %}

templates/licenses/destroy.html
{% extends 'base.html'%}
{% block content %}
    <h2 class="center-items">Data Deleted</h2>
    <p>code: {{object.key}} </p>
    <p>software_name: {{object.software_name}} </p>
    <p>description: {{object.description}} </p>
    <a href="{% url 'listing-licenses' %}">Go back</a>
{% endblock content %}

templates/licenses/show.html
{% extends 'base.html' %}
{% block content %}
    <table class="main-table">
        <h1 style="text-align: center;">Licenses</h1>
        <thead>
            <tr>
                <th>Code</th>
                <th>Software_name</th>
                <th>description</th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            {% for data in object_list %}
                <tr>
                    <td>{{ data.owner }}</td>
                    <td>{{ data.software_name }}</td>
                    <td>{{ data.description }}</td>
                    <td><a href="{% url 'listing-update' pk=data.id %}" >Edit</a></td>
                    <td><a href="{% url 'listing-delete' pk=data.id %}" >Delete</a></td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
    <div class="columns center-items">
        <a id="Add-show-button" href="{% url 'listing-add' %}" class="button">Add</a>
    </div>
{% endblock %}

templates/personal/add.html
{% extends 'base.html' %}
{% load widget_tweaks %}

{% block content %}
    <h2 style="margin: 0 auto;">Adding Personal to TI SUPPORT REPORTS</h2>
    <form method="POST">
        {% csrf_token %}
        <div>
            <label for="id_name"> {{form.name.label}} </label>
            {% render_field form.name%}
        </div>
        <div>
            <label for="id_computer_code"> {{form.computer_code.label}} </label>
            {% render_field form.computer_code%}
        </div>
        <div>
            <label for="id_ubication"> {{form.ubication.label}} </label>
            {% render_field form.ubication%}
        </div>
        <div class="colums center-items">
            <input class="button" type="submit" value="+">
        </div>
    </form>
{% endblock content %}

templates/personal/destroy.html
{% extends 'base.html' %}

{% block content %}
    <h2 class="center-items" style="margin: 0 auto;">Data Deleted</h2>
    <p>name: {{object.name}} </p>
    <p>computer_code: {{object.computer_code}} </p>
    <p>ubication: {{object.ubication}} </p>
    <a href="{% url 'listing-personal' %}">Go back</a>
{% endblock content %}

templates/personal/show.html
{% extends 'base.html' %}
{% block content %}
            <table class="main-table">
                <h1 style="text-align: center;">Personal</h1>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Computer Code</th>
                        <th>Ubication</th>
                        <th>Edit</th>
                        <th>Delete</th>
                    </tr>
                </thead>
                <tbody>
                    {% for data in object_list %}
                        <tr>
                            <td>{{ data.name }}</td>
                            <td>{{ data.computer_code }}</td>
                            <td>{{ data.ubication }}</td>
                            <td><a href="{% url 'personal-edit' pk=data.id %}">Edit</a></td>
                            <td><a href="{% url 'personal-delete' pk=data.id%}">Delete</a></td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        <div class="columns center-items">
            <a id="Add-show-button" href="{% url 'personal-add' %}" class="button">Add</a>
        </div>
{% endblock content %}

templates/software/add.html
{% extends 'base.html'%}
{% load widget_tweaks %}
{% block content %}


<div>
    <div class="row">
        <div class="columns small-12 medium-12 large-12">
            <header class="center-items">
                <h2 style="margin: 0 auto;">Adding TI Support Reports</h2>
            </header>
            <form method="POST">
                {% csrf_token %}
                <div>
                    <label for="id_software"> {{form.software.label}} </label>
                    {% render_field form.software%}
                </div>
                <div>
                    <label for="id_version">{{form.version.label}}</label>
                    {% render_field form.version%}
                </div>
                <div>
                    <label for="id_description">{{form.description.label}}</label>
                    {% render_field form.description%}
                </div>
                <div>
                    <label for="id_date_created">{{form.date_created.label}}</label>
                    {% render_field form.date_created%}
                </div>
                <div>
                    <label for="id_owner">{{form.owner.label}}</label>
                    {% render_field form.owner %}
                </div>
                <div class="colums center-items">
                    <input class="button" type="submit" value="+">
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock %}

templates/software/destroy.html
{% extends 'base.html'%}
{% block content %}

    <h2 class="center-items">Data Deleted</h2>
    <p>id: {{data.id}}</p>
    <p>code: {{data.code}} </p>
    <p>software: {{data.software}} </p>
    <p>version: {{data.version}} </p>
    <p>description: {{data.description}} </p>
    <p>created: {{data.date_created}} </p>
    <a href="{% url 'listing-notes' %}">Go back</a>
{% endblock content %}

templates/software/show.html
{% extends 'base.html' %}
{% block content %}
        <table class="main-table">
            <h1 class="center-items">Notes</h1>
            <thead>
                <tr>
                    <th>Code</th>
                    <th>Software</th>
                    <th>Version</th>
                    <th>description</th>
                    <th>date_created</th>
                    <th>Edit</th>
                    <th>Delete</th>
                </tr>
            </thead>
            <tbody>
                {% for data in list %}
                    <tr>
                        <td>{{ data.owner }}</td>
                        <td>{{ data.software }}</td>
                        <td>{{ data.version }}</td>
                        <td>{{ data.description }}</td>
                        <td>{{ data.date_created }}</td>
                        <td><a href="{% url 'edit-notes' pk=data.id%}">Edit</a></td>
                        <td><a href="{% url 'destroy-notes' pk=data.id%}">Destroy</a></td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>

    <div class="columns center-items">
        <a id="Add-show-button" href="{% url 'add-notes' %}" class="button">Add</a>
    </div>
{% endblock %}